/* file.c  Ver 2.3  1992.3.30. */
/* UNIX X-Window , Turbo-C Version */
/* file open utilities */
/* ́Eo͕ */
/* oCi֐p */

/* FILE *file_read_open(bZ[W()) */
/* ()	fp=file_read_open("Am[hf[^t@C"); */
/* FILE *file_read_open_default(bZ[W(),gq(),t@C(o)) */
/* ()	fp=file_read_open_default("Am[hf[^t@C","dat",filename); */
/* FILE *file_read_open_arg_default(z(),z(),gq(),t@C(o)) */
/* ()	fp=file_read_open_arg_default(argn,args,"df3",filename); */

/* FILE *file_write_open(bZ[W()) */
/* ()	fp=file_write_open("Am[hf[^t@C"); */
/* FILE *file_write_open_default(bZ[W(),gq(),t@C(o)) */
/* ()	fp=file_write_open_default("Am[hf[^t@C","dat",filename); */
/* FILE *file_write_open_arg_default(z(),z(),gq(),t@C(o)) */
/* ()	fp=file_write_open_arg_default(argn,args,"df3",filename); */

/* int *bfile_read_open_default(bZ[W(),gq(),t@C(o)) */
/* ()	fp=file_read_open_default("Am[hf[^t@C","dat",filename); */
/* int *bfile_read_open_arg_default(z(),z(),gq(),t@C(o)) */
/* ()	fp=bfile_read_open_arg_default(argn,args,"df3",filename); */

#include	<stdio.h>
#include	<string.h>
#include	<fcntl.h>
/*#include	<sys/stat.h>*/

#ifndef unix
#include	<io.h>
#define printX		printf
#define getsX(s,n)	gets(s)
#endif

int bfile_read_open_default(char mes[],char defaults[],char filename[])
{
	int	fp;
	char buf[80];

	while(1){
		printX("%s [.%s]= ? ",mes,defaults);
		getsX(buf, sizeof(buf));
		sscanf(buf, "%s", filename);
		if((fp=open(filename,O_RDONLY/*|O_BINARY*/))!=-1) break;
		printX(" %s ܂B\n",filename);
		strcat(filename,".");
		strcat(filename,defaults);
		if((fp=open(filename,O_RDONLY/*|O_BINARY*/))!=-1) break;
		printX(" %s ܂B\n",filename);
	}
	printX(" %s ǂł܂B\n",filename);
	return(fp);
}

int bfile_read_open_arg_default(int argn,char *args[],char defaults[],char filename[])
{
	int	fp;
	int	i;

	if(argn<=1) return(-1);
	for(i=1;i<argn;i++){
		strcpy(filename,args[i]);
		if((fp=open(filename,O_RDONLY/*|O_BINARY*/))!=-1) break;
		printX(" %s ܂B\n",filename);
		strcat(filename,".");
		strcat(filename,defaults);
		if((fp=open(filename,O_RDONLY/*|O_BINARY*/))!=-1) break;
		printX(" %s ܂B\n",filename);
	}
	if(fp!=-1) printX(" %s ǂł܂B\n",filename);
	return(fp);
}

FILE *file_read_open(char mes[])
{
	FILE	*fp;
	char	filename[40];
	char 	buf[80];

	while(1){
		printX("%s = ? ",mes);
		getsX(buf, sizeof(buf));
		sscanf(buf, "%s", filename);
		if((fp=fopen(filename,"r"))!=NULL) break;
		printX(" %s ܂B\n",filename);
	}
	printX(" %s ǂł܂B\n",filename);
	return(fp);
}

FILE *file_read_open_default(char mes[],char defaults[],char filename[])
{
	FILE	*fp;
	char buf[80];

	while(1){
		printX("%s [.%s]= ? ",mes,defaults);
		getsX(buf, sizeof(buf));
		sscanf(buf, "%s", filename);
		if((fp=fopen(filename,"r"))!=NULL) break;
		printX(" %s ܂B\n",filename);
		strcat(filename,".");
		strcat(filename,defaults);
		if((fp=fopen(filename,"r"))!=NULL) break;
		printX(" %s ܂B\n",filename);
	}
	printX(" %s ǂł܂B\n",filename);
	return(fp);
}

FILE *file_read_open_arg_default(int argn,char *args[],char defaults[],char filename[])
{
	FILE	*fp;
	int	i;

	if(argn<=1) return(NULL);
	for(i=1;i<argn;i++){
		strcpy(filename,args[i]);
		if((fp=fopen(filename,"r"))!=NULL) break;
		printX(" %s ܂B\n",filename);
		strcat(filename,".");
		strcat(filename,defaults);
		if((fp=fopen(filename,"r"))!=NULL) break;
		printX(" %s ܂B\n",filename);
	}
	if(fp!=NULL) printX(" %s ǂł܂B\n",filename);
	return(fp);
}

FILE *file_write_open(char mes[])
{
	FILE	*fp;
	char	filename[40];
	char 	buf[80];

	while(1){
		printX("%s = ? ",mes);
		getsX(buf, sizeof(buf));
		sscanf(buf, "%s", filename);
		if((fp=fopen(filename,"w"))!=NULL) break;
		printX(" %s ܂B\n",filename);
	}
	printX(" %s ɏĂ܂B\n",filename);
	return(fp);
}

FILE *file_write_open_default(char mes[],char defaults[],char filename[])
{
	FILE	*fp;
	char buf[80];

	while(1){
		fprintf(stderr,"%s [.%s]= ? ",mes,defaults);
		getsX(buf, sizeof(buf));
		sscanf(buf, "%s", filename);
		if(strchr(filename,'.')==NULL){
			strcat(filename,".");
			strcat(filename,defaults);
		}
		if((fp=fopen(filename,"w"))!=NULL) break;
		printX(" %s ɏ܂B\n",filename);
	}
	printX(" %s ɏĂ܂B\n",filename);
	return(fp);
}

FILE *file_write_open_arg_default(int argn,char *args[],char defaults[],char filename[])
{
	FILE	*fp;
	int	i;

	if(argn<=1) return(NULL);
	for(i=1;i<argn;i++){
		strcpy(filename,args[i]);
		if(strchr(filename,'.')==NULL){
			strcat(filename,".");
			strcat(filename,defaults);
		}
		if((fp=fopen(filename,"w"))!=NULL) break;
		printX(" %s ɏ܂B\n",filename);
	}
	if(fp!=NULL) printX(" %s ɏĂ܂B\n",filename);
	return(fp);
}
