/* fitread.c  Ver 2.0  1991.8.3. */
/* tBbgt@Cǂ */
/* ftHg */
/* file.c Ver2.0 N邱 */

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <stdlib.h>

#ifndef unix
#include <dos.h>
#endif

#include "file.h"
#include "fitspec.h"

int
fit_fileread(filename,subfilenum,spect,argn,args)
char filename[];
int *subfilenum;
struct fit_spec *spect[];
int argn;
char *args[];
{
	int			line,num,i;
	FILE		*fp;
	static char	data[150][160],work[300],
			beginword[50]="***** SUMMARY RESULTS OF SPECTRAL FITTING";

	if((fp=file_read_open_arg_default(argn,args,"fit",filename))==NULL){
		fp=file_read_open_default("̓tBbgt@C","fit",filename);
	}

	line=0;			/* data[0..line-1]ɃXyNgt@Cǂݍ */
	num=0;
	while(fgets(work,300,fp)!=NULL){
		i=strlen(work)-1;
		do{
			i--;
		}while(work[i]==' ' && i!=-1);
		work[i+1]=0;
/*		puts(work);*/
		strcpy(data[line],work);
		if(strstr(data[line],beginword)!=NULL){
			num++;
			if(num>1){
				fit_dataread(data,line,spect[num-2]);
			}
			printf(" %s ̃Tut@C %d ǂł܂B%c",filename,num,0x0d);
			strcpy(data[0],data[line]);
			line=0;
		}
		line++;
	}
	fclose(fp);
/*puts("a");*/
	if(num>0){
		if(fit_dataread(data,line,spect[num-1])==0) num--;
	}
	if(num==0){
		printf("\n %s ɂ tBbgt@C܂B\n",filename);
	}
	*subfilenum=num;
	return(num);	/* _0 */
}

/* beginwordŎn܂1ubNf[^ǂݍ */
int
fit_dataread(data,line,spect)
char data[150][160];
int line;
struct fit_spec *spect;
{
	int	i,j,k,n,cont;
	static char	work[175],*p;

	i=0;
	if(gountil(data,"DATASET NAME",&i,line)==1){
		printf("f[^܂B\n");
		return(0);	/* 0̓_ */
	}
	strcpy(spect->datafile,strchr(data[i],(int)';')+2);	/* t@C */
	k=strlen(spect->datafile);
	if(spect->datafile[k-1]=='\n') spect->datafile[k-1]=0;

	i++;
	strcpy(work,strchr(data[i],(int)';')+1);
	sscanf(work,"%d",&(spect->subfilenum));
	p=strchr(work,(int)';')+1;
	strcpy(work,p);
	sscanf(work,"%d",&(spect->datanum));

	i++;
	p=strchr(data[i],';');
	p++;
	strcpy(spect->binning,p);
	p=&(spect->binning[strlen(spect->binning)-1]);
	if(*p < '0') *p=0;
	if(strlen(spect->binning)<48) strcat(spect->binning,data[i+1]);

	gountil(data,"NO. OF DATA",&i,line);
	sscanf(strchr(data[i],(int)';')+1,"%d",&(spect->ndata));

	gountil(data,"MODEL FORMULA",&i,line);
	i++;
	p=data[i];
	while(*p==' ') p++;
	strcpy(spect->modelformula,p);
	spect->ncompo=1;
	while(*p){		/* Ȉ  a */
		if(*p=='+') spect->ncompo++;
		p++;
	}
	if(spect->ncompo>COMPONUM){
		printf("EROOR !!! Components too many (%d). Chenge COMPONUM.\n",spect->ncompo);
		exit(0);
	}

	gountil(data,"PARAMETERS",&i,line);
	i++;
	strcpy(work,data[i]);
	if(strstr(data[i+1],"INITIAL")==NULL){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
		cont=1;
		i++;
	}
	else cont=0;

	k=strlen(work);
	n=25;
	do{
		sscanf(&work[n],"%d",&(spect->npara));
		n+=9;
	}while(n<k);

	if(spect->npara>PARANUM){
		printf("EROOR !!! Parameters too many (%d). Chenge PARANUM.\n",spect->npara);
		exit(0);
	}

	gountil(data,"INITIAL",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->parainit[n]));
	}

	gountil(data,"LOWER",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paralow[n]));
	}

	gountil(data,"UPPER",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paraup[n]));
	}

	gountil(data,"FINAL",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->parafinal[n]));
	}

	gountil(data,"90% ERROR",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paraerr[n]));
	}

	gountil(data,"CHI SQUARED VALUE",&i,line);
	p=strchr(data[i],'=');
	p+=1;
	sscanf(p,"%lf",&(spect->chisqr));
	p=strchr(p,'=');
	p++;
	sscanf(p,"%d",&(spect->dof));

	spect->nparaeff=spect->npara;
	for(i=0;i<spect->npara;i++)
		if((spect->paraup[i]==0)&&(spect->paralow[i]==0)){
			spect->nparaeff--;
		}

	if(spect->ndata-spect->nparaeff!=spect->dof){
		printf("data error !!!\n");
		printf("Data of freedom  Nbin - Nparaeff ȂB\n");
		printf("DOF=%d, Nbin=%d,  Nparaeff=%d Npara=%d\n",
			spect->dof,spect->ndata,spect->nparaeff,spect->npara);
/*		for(k=0;k<line;k++) printf("%s",data[k]);*/
		exit(1);
	}

	gountil(data,"REDUCED VALUE",&i,line);
	p=strchr(data[i],'=');
	p++;
	sscanf(p,"%lf",&(spect->chisqrred));

	i++;
	p=strchr(data[i],';');
	p++;
	sscanf(p,"%d",&(spect->simplex));
	p+=23;
	sscanf(p,"%d",&(spect->lsq));

	i++;
	p=data[i]+1;
	while(*p==' ') p++;
	strcpy(spect->converge,p);

	i+=3;
/*	printf("spect->ndata=%d\n",spect->ndata);*/
	for(k=0;k<spect->ndata;){
/*		printf("k=%d ",k);*/
		if(data[i][10]=='-'){
			strcpy(work,data[i]);
			if(cont){
				work[strlen(work)-1]=0;
				strcat(work,data[i+1]);
				i++;
			}
			p=work;
			sscanf(&(work[ 1]),"%lf",&(spect->es[k]));
			sscanf(&(work[11]),"%lf",&(spect->ee[k]));
			sscanf(&(work[16]),"%lf",&(spect->counts[k]));
			sscanf(&(work[29]),"%lf",&(spect->stdv[k]));
			sscanf(&(work[37]),"%lf",&(spect->model[k]));
			sscanf(&(work[49]),"%lf",&(spect->res[k]));
			for(j=0;j<spect->ncompo;j++){
				sscanf(&(work[63+12*j]),"%lf",&(spect->compo[j][k]));
			}
			k++;
		}
		i++;
	}
	return(1);	/* 1OK */
}

int
gountil(data,s,i,line)
char data[][160],s[];
int *i,line;
{
/*	puts(s);*/
	while((strstr(data[*i],s)==NULL)&&(*i<line)) (*i)++;
	if(*i>=line){
		printf(" ERROR !!  %s ̃f[^܂B\n",s);
		return(1);
	}
	return(0);
}
