/* fitscan.c  Ver 1.0   1992.4.21. */
/* եåȷ̤ɤ߹ǡscan profile */
/* pasfont.datȤʤ */
/* plot1.c, scanread.cȥ󥯤뤳 */
/* ESCǽλ */
/* Use Large Model */

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <malloc.h>

#include "fitscan.h"

main(int argn, char *args[])

{
	static struct fit_spec	*spect[SPECTNUM];
	static double	xmin,xmax,ymin,ymax,total;
	static char	filename[30],title[80],x_ziku[80],y_ziku[80];
	static int	i,subspecnum,sf,xlog,ylog;
	static char	work[100];

	for(i=0;i<SPECTNUM;i++){
		if((spect[i]=malloc(sizeof(struct fit_spec)))==NULL){
			printf("꤬­ޤ%d\n",i);
			exit(1);
		}
	}

	if(fit_fileread(filename,&subspecnum,spect,argn,args)==0) exit(0);

	sf = -1;
	while(1){
		printf(" %s ˤ %d ĤΥڥȥեåȤޤ\n",
			filename,subspecnum);
		if(subspecnum==1 && sf==-1) sf=1;
		else{
			do{
				printf("ܤΥեåȤɽޤ ");
				sf=subspecnum+1;
				gets(work);
				i=work[0];
				i=toupper(i);
				if(i==0) exit(0);
				else sscanf(work,"%d",&sf);
			}while((sf<1)||(sf>subspecnum));
		}

		sf--;
		xlog=0;
		xmin=100.0;
		xmax=0.0;
		ylog=0;
		ymin=0.0;		/* ylog=1 λ ymax/ymin  Y ηͿ */
		ymax=0.0;

		total=0;
		for(i=0;i<spect[sf]->ndata;i++) total+=spect[sf]->counts[i];

		sprintf(title,"              %s %d %d",
			 spect[sf]->datafile,spect[sf]->subfilenum,spect[sf]->datanum);

		sprintf(x_ziku,"       ANGLE [deg]      X2red=%5.2lf",
			spect[sf]->chisqrred);
		strcpy(y_ziku, "");

		text_write(spect[sf]);
		fitspec(spect[sf],xlog,xmin,xmax,ylog,ymin,ymax,title,x_ziku,y_ziku);
		sf++;
	}
}

text_write(spect)
struct fit_spec *spect;
{
	int	k;
	char    work[255];

	screen(3,0,300,1);
	cls(3);

	smallmoji(1,400,"ENERGY BANDS USED :",5,0,0);
	sprintf(work,"%s",spect->binning); smallmoji(1,413,work,5,0,0);
	sprintf(work,"NO. of DATA : %d",spect->ndata); smallmoji(1,426,work,5,0,0);
	smallmoji(1,439,"MODEL :",5,0,0);
	sprintf(work,"%s",spect->modelformula); smallmoji(1,452,work,5,0,0);

	smallmoji(1,465,"NUMBER : ",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%4d   ",k+1); smallmoji(57+56*k,465,work,5,0,0);
	}
	smallmoji(1,478,"INITIAL:",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->parainit[k]); smallmoji(57+56*k,478,work,5,0,0);
	}
	smallmoji(1,491,"LOWER  :",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->paralow[k]); smallmoji(57+56*k,491,work,5,0,0);
	}
	smallmoji(1,504,"UPPER  :",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->paraup[k]); smallmoji(57+56*k,504,work,5,0,0);
	}
	smallmoji(1,530,"FINAL  :",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->parafinal[k]); smallmoji(57+56*k,530,work,5,0,0);
	}
	smallmoji(1,543,"90 ERR:",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->paraerr[k]); smallmoji(57+56*k,543,work,5,0,0);
	}

	sprintf(work,"    2      %7.2lf   ",spect->chisqr);
	smallmoji(1,569,work,5,0,0);
	sprintf(work,"(D.O.F.=%d)",spect->dof);
	smallmoji(201,569,work,5,0,0);
	sprintf(work,"reduced 2  %7.2lf",spect->chisqrred);
	smallmoji(1,582,work,5,0,0);
	sprintf(work,"SIMPLEX : %d STEPS",spect->simplex);
	smallmoji(1,608,work,5,0,0);
	sprintf(work,"LSQ     : %d STEPS",spect->lsq);
	smallmoji(1,621,work,5,0,0);
	sprintf(work,"%s",spect->converge);
	smallmoji(1,634,work,5,0,0);
}

fitspec(spect,xlog,xmin,xmax,ylog,ymin,ymax,title,x_ziku,y_ziku)
struct fit_spec *spect;
double xmin,xmax,ymin,ymax;
int xlog,ylog;
char title[],y_ziku[],x_ziku[];
{
	static struct fit_spec	spect1;
	double			gx0, gx1, gy0, gy1, xunit, yunit,dum,
					x[100],xstdv[100],y[100],ystdv[100];
	int				i,j;
/*	char			s[1]=""; */

	spect1 = *spect;
	gx0 = 150.0;
	gx1 = 470.0;
	gy0 = 145.0;
	gy1 = 370.0;
	xunit = 1.0;

	for(i=0;i<spect1.ndata;i++){
		x[i]=(spect1.ee[i]+spect1.es[i])/2;
		xstdv[i]=spect1.ee[i]-x[i];
		dum=1/(spect1.ee[i]-spect1.es[i]);
		y[i]=spect1.counts[i]*dum;
		ystdv[i]=spect1.stdv[i]*dum;
		spect1.model[i]=spect1.model[i]*dum;
		for(j=0;j<spect1.ncompo;j++) spect1.compo[j][i]=spect1.compo[j][i]*dum;
	}

	if(xlog==0){
		for(i=0;i<spect1.ndata;i++){
			if(xmax<x[i]) xmax=x[i];
			if(xmin>x[i]) xmin=x[i];
		}
        dum=(xmax-xmin)*0.1;
        xmax += dum; xmin -= dum;
	}

	if(ylog==0){
		for(i=0;i<spect1.ndata;i++){
			if(ymax<y[i]) ymax=y[i]*1.1;
		}
                yunit=pow(10.0,floor(log10(ymax)));
	}

	axsa(gx0,gx1,xmin,xmax,xlog,xunit,gy0,gy1,ymin,ymax,ylog,yunit,
		" ",y_ziku,title,1);
/*	printf("%lf %lf %lf %lf %d %lf %lf %lf %lf %lf %d %lf %s %s %s\n",gx0,gx1,xmin,xmax,xlog,xunit,gy0,gy1,ymin,ymax,ylog,yunit,
		" ",y_ziku,title);
*/
	pointb(x,xstdv,y,ystdv,spect1.ndata-1,6,0);
	hist(spect1.model,spect1.es,spect1.ee,spect1.ndata-1);
	for(i=0;i<spect1.ncompo;i++)
		hist(spect1.compo[i],spect1.es,spect1.ee,spect1.ndata-1);

	gy0 = 50.0;
	gy1 = 120.0;
	yunit = 3.0;
	ylog = 0;
	ymin= -6;
	ymax=  6;
	strcpy(y_ziku,"RES.");

	axsa(gx0,gx1,xmin,xmax,xlog,xunit,gy0,gy1,ymin,ymax,ylog,yunit,
		x_ziku,y_ziku," ",4);
/*	printf("%lf %lf %lf %lf %d %lf %lf %lf %lf %lf %d %lf %s %s %s\n",gx0,gx1,xmin,xmax,xlog,xunit,gy0,gy1,ymin,ymax,ylog,yunit,
		" ",y_ziku,title);
*/
	for(i=0;i<spect1.ndata;i++){
		y[i]=spect1.res[i]/spect1.stdv[i];
		ystdv[i]=1.0;
	}

	pointb(x,xstdv,y,ystdv,spect1.ndata-1,6,0);
	flush();
}
