#include <math.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <string.h>

static double x_0,y_0,x_1,y_1,xmin,xmax,ymin,ymax,xstep,ystep,xunit,yunit;
static int	xlog,ylog;

axsa (x01,x11,xmin1,xmax1,xlog1,xunit1,y01,y11,ymin1,ymax1,ylog1,yunit1,		x_ziku,y_ziku,title,no)
double	x01,x11,xmin1,xmax1,xunit1,y01,y11,ymin1,ymax1,yunit1;
int	xlog1,ylog1,no;
unsigned char	x_ziku[80],y_ziku[80],title[80];
{
	double	w,x,xx,get_x(),y,yy,get_y(),next_num(),dd=3.0;
	int		shisuu,ix(),iy(),moji_suu(),itoa(),sw;
	char	moji[20];

	x_0 = x01;x_1=x11;xmin=xmin1;xmax=xmax1;xunit=xunit1;
	y_0=y01;y_1=y11;ymin=ymin1;ymax=ymax1;yunit=yunit1;
	xlog=xlog1;ylog=ylog1;

	line(ix(x_0),iy(y_0),ix(x_1),iy(y_1),4,1,0,0); 
	if((sw = no & 1)==0)
	  symbol( 1,ix(floor((x_0+x_1)/2.0)) - 4 * moji_suu(x_ziku),
				iy(y_0)+28,
				5, x_ziku);
/*	symbol( 21,ix(x_0)-56,
				iy(floor((y_0+y_1)/2.0)) + 4 * moji_suu(y_ziku),
				5, y_ziku); */
	no>>=1;
	if((sw = no & 1)==0)
	  symbol( 21,ix(x_0)-148,
				iy(y_1)-24,
				5, y_ziku);
	no>>=1;
	if((sw = no & 1)==0)
	  symbol( 1 ,ix(floor((x_0+x_1)/2.0)) - 4 * moji_suu(title)+5,
				iy(y_1)-24,
				5, title);

	if(xlog==1){
		xunit=10.0;
		xstep=(x_1-x_0)/(log10(xmax/xmin));
		x=xmin;
		while((w=next_num(x))<=xmax){
			xx=get_x(w);  /* get_x;  value==> position*/
			rfline(xx,y_0,xx,y_0+dd,4,0,0xffff,0);
			if( fabs(log10(w) - floor(log10(w)))< 1e-15)
				{
				shisuu = (int)floor(log10(w));
				symbol( 1, ix(xx)-8, iy(y_0)+5, 5, "10");
				itoa (shisuu, moji, 10);
				symbol( 0, ix(xx)+8, iy(y_0)-5, 5, moji);
				}
			rfline(xx,y_1,xx,y_1-dd,4,0,0xffff,0);
			x=w;
		}
	}
	else{
		symbol( 1, ix(x_1)+16, iy(y_0)+21, 5, "*10");
		shisuu = (int)floor(log10(xunit));
		itoa (shisuu, moji, 10);
		symbol( 0, ix(x_1)+40, iy(y_0)+21, 5, moji);
		xstep=(x_1-x_0)/((xmax-xmin)/xunit);
		for(x=xmin;x<=xmax;x=x+xunit){
			xx=get_x(x);
			rfline(xx,y_0,xx,y_0+dd,4,0,0xffff,0);
			gcvt (x/pow(10.0,(double)shisuu), 3, moji);
			symbol( 1, ix(xx), iy(y_0)+5, 5, moji);
			rfline(xx,y_1,xx,y_1-dd,4,0,0xffff,0);
		}
	}
	if(ylog==1){
		yunit=10.0;
		ystep=(y_1-y_0)/(log10(ymax/ymin));
		y=ymin;
		while((w=next_num(y))<=ymax){
			yy=get_y(w);
			rfline(x_0,yy,x_0+dd,yy,4,0,0xffff,0);
			if( fabs(log10(w) - floor(log10(w)))< 1e-15)
				{
				shisuu = (int)floor(log10(w));
				symbol( 21, ix(x_0)-27, iy(yy)-2, 5, "10");
				itoa (shisuu, moji, 10);
				symbol( 20, ix(x_0)-12, iy(yy)-15, 5, moji);
				}
			rfline(x_1,yy,x_1-dd,yy,4,0,0xffff,0);
			y=w;
		}
	}
	else{
		symbol( 21, ix(x_0)-59, iy(y_1)-6, 5, "*10");
		shisuu = (int)floor(log10(yunit));
		itoa (shisuu, moji, 10);
		symbol( 20, ix(x_0)-34, iy(y_1)-15, 5, moji);
		ystep=(y_1-y_0)/((ymax-ymin)/yunit);
		for(y=ymin;y<=ymax;y=y+yunit){
			yy=get_y(y);
			rfline(x_0,yy,x_0+dd,yy,4,0,0xffff,0);
			gcvt (y/pow(10.0,(double)shisuu), 3, moji);
			symbol( 21, ix(x_0)-21, iy(yy)-12, 5, moji);
			rfline(x_1,yy,x_1-dd,yy,4,0,0xffff,0);
		}
	}
}
int itoa(kazu,moji,kisuu)
int kazu,kisuu;
char moji[100];
{
        sprintf(moji,"%d",kazu);
}
double next_num(x)
double x;
{
	double a,b,c;
	int    n;

	a=floor(log10(x));
	b=pow(10.0,a);
	n=(int)floor(x/b);

	c=b*((double)n+1.0);

	return(c);
}

rfline(xx1,yy1,xx2,yy2,palet,type,style,mode)
double  xx1,xx2,yy1,yy2;
int     palet,type,style,mode;
{
	int  ix1,ix2,iy1,iy2,ix(),iy();

	ix1 = ix(xx1);
	ix2 = ix(xx2);

	iy1 = iy(yy1);
	iy2 = iy(yy2);
/*	wait_gdc_finishes(); */
	if ( (ix1 == ix2) && (iy1 == iy2) )
		pset ( ix1 , iy1 , palet );
	else
		line(ix1,iy1,ix2,iy2,palet,0,type,style);
}

int	ix(xx)
double	xx;
{
	int	ret_val;

	ret_val = (int)floor( xx - 0.5 );
	return(ret_val);
}

int	iy(yy)
double	yy;
{
	int	ret_val;

	ret_val = (int)floor( 400.0 - yy - 0.5 );
	return(ret_val);
}

double get_x(x)
double x;
{
	/* return coordinate value for x axis data */
	if	(x>xmax)	return(x_1);
	else if	(x<xmin)	return(x_0);
	if(xlog==1)		return(x_0 + log10(x/xmin)*xstep);
	else			return(x_0 + (x-xmin)/xunit*xstep );
}

double get_y(y)
double y;
{
	/* return coordinate value for y axis data */
	if	(y>ymax)	return(y_1);
	else if	(y<ymin)	return(y_0);
	if(ylog==1)		return(y_0 + log10(y/ymin)*ystep);
	else			return(y_0 + (y-ymin)/yunit*ystep );
}
pointb(xdata,xstdv,ydata,ystdv,ndata,col,mode)
int col,mode;
double xdata[48],xstdv[48],ydata[48],ystdv[48];
int	ndata;
{
	int i;
	double xx,xx1,xx2,yy,yy1,yy2,xx3,yy3;

	for(i=0;i<ndata;i++){
		xx=get_x(xdata[i]);
		xx1=get_x(xdata[i]-xstdv[i]);
		xx2=get_x(xdata[i]+xstdv[i]);
		yy=get_y(ydata[i]);
		yy1=get_y(ydata[i]-ystdv[i]);
		yy2=get_y(ydata[i]+ystdv[i]);
		rfline(xx1,yy,xx2,yy,col,0,0xffff,3);
		rfline(xx,yy1,xx,yy2,col,0,0xffff,3);
		if(mode==0) continue;
		if(i==0){
		  xx3=xx; yy3=yy;
		}
		rfline(xx3,yy3,xx,yy,col,0,0,3);
		xx3=xx; yy3=yy;
	}
}

hist(ydata,en1,en2,ndata)
double ydata[48],en1[48],en2[48];
int	ndata;
{
	int i;
	static double xx1,xx2,yy,yy1;

	for(i=0;i<=ndata;i++){
		if(i==0){
			xx1=get_x(en1[i]);
			xx2=get_x(en2[i]);
			yy=get_y(ydata[i]);
			rfline(xx1,yy,xx2,yy,5,0,0xffff,3);
		}
		else{
			yy1=get_y(ydata[i]);
			xx1=get_x(en1[i]);
			if(xx1==xx2){
				rfline(xx1,yy,xx1,yy1,5,0,0xffff,3);
			}
			xx2=get_x(en2[i]);
			yy=yy1;
			rfline(xx1,yy,xx2,yy,5,0,0xffff,3);
		}
	}
}
draw1b ( xdata , xstdv , ydata , ystdv, palet)
double	xdata , xstdv , ydata , ystdv;
int	palet;
{
	double	xx , xx1 , xx2 , yy , yy1 , yy2;

	xx = get_x( xdata );
	xx1 = get_x( xdata - xstdv );
	xx2 = get_x( xdata + xstdv );
	yy = get_y( ydata );
	yy1 = get_y( ydata - ystdv );
	yy2 = get_y( ydata + ystdv );
	if( (xdata+xstdv>=xmin && xmax>=xdata-xstdv)
	&& (ydata+ystdv>=ymin && ymax>=ydata-ystdv) )
		{
		if (ymax>=ydata && ydata>=ymin)
			rfline ( xx1, yy, xx2, yy, palet, 0, 0xffff, 3 );
		if (xmax>=xdata && xdata>=xmin)
			rfline ( xx, yy1, xx, yy2, palet, 0, 0xffff, 3 );
		}
}

load_font()
{
}

symbol( ij, wx, wy, iro, moji )
int	ij, wx, wy, iro;
unsigned char	moji[];
{
	int		mode;

/*	wait_gdc_finishes(); */
	mode=0;
	if ( ij == 0 )		smallmoji( wx,wy,moji,iro,mode,0);
	else if (ij ==  1)	normalmoji(wx,wy,moji,iro,mode,0);
	else if (ij == 10)	smallmoji( wx,wy,moji,iro,mode,3);
	else if (ij == 11)	normalmoji(wx,wy,moji,iro,mode,3);
	else if (ij == 20)	smallmoji( wx,wy,moji,iro,mode,1);
	else if (ij == 21)	normalmoji(wx,wy,moji,iro,mode,1);
}

int	moji_suu(moji)
unsigned char	moji[];
{
	int	i;

	for( i=0; moji[i] != 0x00; i++);
	return (i);
}

