/* spect.c  Ver 3.0   1990.7.17. */
/* buffer150ˤ  1990.9.29. */
/* plot1.cȤ      1991.2. 2. */
/* ڥȥեɤ߹ǡڥȥ */

/* plot1.obj ȥ󥯤뤳 */

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <malloc.h>

#define sqre(x) (x*x)
#define SPECTNUM 20

struct lac_spectrum{
	int		chnum;
	double	x0[49],x1[48],x2[48],
			livetime,alpha,delta;
	char	target[11],sensor[9],starttime[22],endtime[22],comment[100];
};

main()
{
	static struct lac_spectrum	*spect[20],*spect1,*spect2;
	static double	xmin,xmax,ymin,ymax,total;
	static char	filename[30],work[160],title[80],x_ziku[80],y_ziku[80];
	int 		subfilenum,sf,sf0,xlog,ylog,sa,i;

	for(i=0;i<SPECTNUM;i++){
		if((spect[i]=malloc(sizeof(struct lac_spectrum)))==NULL){
			printf("can't obtain memory\n");
			exit(0);
		}
        }

	xlog=1;
	ylog=1;
	ymin=1.0;	/* ylog=1 λ ymax/ymin  Y ηͿ */
	ymax=100000.0;

/*	fkey(0);*/
	if(fileread(filename,&subfilenum,spect)==0) exit(0);

	sf=1;
	sa=0;
	do{
		locate(1,23,1);
		printf(" %s ˤ %d ĤΥ֥ե뤬ޤ\n",filename,subfilenum);

		if(subfilenum>0) do{
			if(sa){
				do{
					locate(1,24,1);
					printf(
		"ܤΥ֥ե뤫ޤ(C:ԡ,N:ɽ)"
					);
					sf0=subfilenum+1;
					gets(work);
					if(work[0] == 0) exit(0);
					else if((work[0]=='c')||(work[0]=='C'))locate(2,2,2); /* copy(2); */
					else if((work[0]=='n')||(work[0]=='N')){sa=0;sf0=1;}
						else sscanf(work,"%d",&sf0);
				}while((sf0<1)||(sf0>subfilenum));
				if(sa)
				printf("ܤΥ֥եޤ    ");
			}
			if(sa==0){
				locate(1,24,1);
				printf(
			"ܤΥ֥եɽޤ (C:ԡ,S:ɽ)    "
				);
			}
			sf=subfilenum+1;
			gets(work);			
			i=work[0];
			i=toupper(i);
			if(i==0) exit(0);
			else if(i=='C') locate(2,3,9); /* copy(2); */
			else if(i=='S') sa=1;
				else sscanf(work,"%d",&sf);
		}while((sf<1)||(sf>subfilenum));

		spect1 = spect[sf-1];
		if(sa){
			spect2 = spect[sf0-1];
			hikizan(spect1,spect2);
		}

		if(spect1->x0[spect1->chnum-1] < 40.0){
			xmin=0.2;
			xmax=50.0;
		}
		else{
			xmin=1.0;
			xmax=70.0;
		}

		total=0;
		for(i=0;i<spect1->chnum;i++) total+=spect1->x1[i];

		if(sa) sprintf(title,"%7.2lfc/s   %s(%d-%d)   %7.1lfs",
					total,spect1->target,sf0,sf,spect1->livetime);
		else   sprintf(title,"%7.2lfc/s   %s(%d)   %7.1lfs",
					total,spect1->target,sf,spect1->livetime);
		sprintf(x_ziku,"            ENERGY [KeV]    (%6.2lf,%6.2lf)",
			spect1->alpha,spect1->delta);
		strcpy(y_ziku, "COUNTS [c/s/KeV]");

		lacspec(spect1,xlog,xmin,xmax,ylog,ymin,ymax,
			title,x_ziku,y_ziku);
	}while(subfilenum>0);
}

fileread(filename,subfilenum,spect)
char filename[];
int *subfilenum;
struct lac_spectrum *spect[];
{
	int			line,num,i;
	FILE		*fp;
	static char	data[150][160];

	while(1){
		printf("\nϥڥȥե̾ = ");
		gets(filename);
		if((fp=fopen(filename,"r"))!=NULL) break;
		printf("%s ȤեϤޤ\n",filename);
	}
	printf(" %s ɤǤޤ%c\n",filename,0x0d);

	line=0;			/* data[0..line-1]˥ڥȥեɤ߹ */
	num=0;
	while(fgets(data[line],159,fp)!=NULL){
		if(strncmp(data[line],"ALAC",4)==0){
			num++;
			if(num>1){
				dataread(data,line,spect[num-2]);
			}
			printf(" %s Υ֥ե %d ɤǤޤ%c",filename,num,0x0d);
			strcpy(data[0],data[line]);
			line=0;
		}
		if(num>0){
			line++;
			if(line>=150){
				num= -1;
				break;
			}
		}
	}
	fclose(fp);

	if(num>0){
		if(dataread(data,line,spect[num-1])==0) num--;
	}
	else if(num==0){
		printf("\n %s ˤ ڥȥե뤬ޤ\n",filename);
	}
	else if(num==-1){
		printf("\n !!!!Υڥȥե礭ޤ!!!!\n");
		num=0;
	}
	*subfilenum=num;
	return(num);	/* 0 */
}

/* ALACǻϤޤ1֥åǡɤ߹ */
dataread(data,line,spect)
char data[80][160];
int line;
struct lac_spectrum *spect;
{
	int		n0,n1,n2,i,ret;
	char	work[160],ch[4],*p;

	strcpy(work,data[0]);	/* å̾ */
	work[37]=0;
	strcpy(spect->target,&(work[27]));
	strcpy(spect->comment,&(work[50]));

	ret=n0=n1=n2=0;
	for(i=0;i<line;i++){
		switch(data[i][0]){
			case 'B':	sscanf(&(data[i][41]),"%lf",&(spect->livetime));
						sscanf(&(data[i][62]),"%8s",spect->sensor);
						sscanf(&(data[i][1]),
							"%2s/%2s/%2s %2s:%2s:%2s.%3s",spect->starttime);
						sscanf(&(data[i][16]),
							"%2s/%2s/%2s %2s:%2s:%2s.%3s",spect->endtime);
						ch[0]=data[i][86];
						ch[1]=data[i][87];
						ch[2]=data[i][88];
						ch[3]=0;
						sscanf(ch,"%d",&(spect->chnum));
						break;
			case 'S':	sscanf(&(data[i][2]),"%lf",&(spect->alpha));
						sscanf(&(data[i][9]),"%lf",&(spect->delta));
						break;
			case '0':	p= &(data[i][1]);
						dtoe(p);
						while(sscanf(p,"%le",&(spect->x0[n0]))!=EOF){
							p+=12;
							n0++;
						}
						break;
			case '1':	p= &(data[i][1]);
						dtoe(p);
						while(sscanf(p,"%le",&(spect->x1[n1]))!=EOF){
							p+=12;
							n1++;
						}
						ret=1;
						break;
			case '2':	p= &(data[i][1]);
						dtoe(p);
						while(sscanf(p,"%le",&(spect->x2[n2]))!=EOF){
							p+=12;
							n2++;
						}
						break;
		}
	}
	return(ret);	/* 0 */
}

hikizan(spect1,spect2)
struct lac_spectrum *spect1,*spect2;
{
	int	i;

	if(spect1->chnum!=spect2->chnum){
		if(spect1->chnum==48 && spect2->chnum==12){
			printf("ͥ12줷ޤ\n");
			spect1->chnum=12;
			spect1->x0[0]=spect2->x0[0];
			for(i=0;i<12;i++){
				spect1->x0[i+1]=spect2->x0[i+1];
				spect1->x1[i]=spect1->x1[4*i+0]+spect1->x1[4*i+1]
							+spect1->x1[4*i+2]+spect1->x1[4*i+3];
				spect1->x2[i]=sqrt(sqre(spect1->x2[4*i+0])
								 +sqre(spect1->x2[4*i+1])
								 +sqre(spect1->x2[4*i+2])
								 +sqre(spect1->x2[4*i+3]));
			}
		}
		else if(spect1->chnum==12 && spect2->chnum==48){
			printf("ͥ12줷ޤ\n");
			spect2->chnum=12;
			spect2->x0[0]=spect1->x0[0];
			for(i=0;i<12;i++){
				spect2->x0[i+1]=spect1->x0[i+1];
				spect2->x1[i]=spect2->x1[4*i+0]+spect2->x1[4*i+1]
							 +spect2->x1[4*i+2]+spect2->x1[4*i+3];
				spect2->x2[i]=sqrt(sqre(spect2->x2[4*i])
								   +sqre(spect2->x2[4*i+1])
								   +sqre(spect2->x2[4*i+2])
								   +sqre(spect2->x2[4*i+3]));
			}
		}
		else{
			printf("ͥ %d  %d Ǥ\n",spect1->chnum,spect2->chnum);
			exit(1);
		}
	}
	for(i=0;i<spect1->chnum;i++){
		spect1->x1[i]=spect2->x1[i] - spect1->x1[i];
		spect1->x2[i]=sqrt(sqre(spect2->x2[i] * spect2->livetime)
						  +sqre(spect1->x2[i] * spect1->livetime)
					  )/(spect1->livetime + spect2->livetime);
	}
	spect1->livetime=spect2->livetime;
}

lacspec(spect,xlog,xmin,xmax,ylog,ymin,ymax,title,x_ziku,y_ziku)
struct lac_spectrum *spect;
double xmin,xmax,ymin,ymax;
int xlog,ylog;
char title[],y_ziku[],x_ziku[];
{
	double			gx0, gx1, gy0, gy1, xunit, yunit,dum,
					x[48],xstdv[48],y[48],ystdv[48];
	int				ndata;

	gx0 = 150.0;
	gx1 = 500.0;
	gy0 =  50.0;
	gy1 = 350.0;
	xunit = 0.0;
	yunit = 0.0;

	screen(3,0,0,1);
	cls(3);

	for(ndata=0;ndata<spect->chnum;ndata++){
		x[ndata]=(spect->x0[ndata]+spect->x0[ndata+1])/2;
		xstdv[ndata]=spect->x0[ndata+1]-x[ndata];
		dum=1/(spect->x0[ndata+1]-spect->x0[ndata]);
		y[ndata]=spect->x1[ndata]*dum;
		ystdv[ndata]=spect->x2[ndata]*dum;
	}

	if(ylog==1){
		if(ymax==0.0){
			printf(" ymax0Ǥ\n");
			return;
		}
		ymin=ymin/ymax;
		ymax=0;
		for(ndata=0;ndata<spect->chnum;ndata++)
			if(ymax<y[ndata]) ymax=y[ndata];
		if(ymax==0){
			printf(" ǡ٤0ʲǤ\n");
			return;
		}
		ymax=exp(floor(log(ymax))+1.0);
		ymin=ymax*ymin;
	}

	axsa(gx0,gx1,xmin,xmax,xlog,xunit,gy0,gy1,ymin,ymax,ylog,yunit,
	x_ziku,y_ziku,title,0);

	pointb(x,xstdv,y,ystdv,spect->chnum-1,6,0);
}

dtoe(p)	/* ʸ D  e ľ */
char *p;
{
	while(*p){
		if(*p=='D') *p='e';
		p++;
	}
}

locate(x,y,c)
int x,y,c;
{
}
