/* contourp.h */
/* contour.h  nz,nr,ncont n  for pot.c */
/* v : data no start address */
/* XS,XE,YS,YE (Ot̎l)́Amain #define邱 */

static unsigned int	NZ,NR,nz1;

contour(v,nz,nr,ncont,vcont)
float v[],vcont[];
unsigned int nz,nr,ncont;
{
	int		i,j,io,jo,conto,sig,sign,dot;
	static float	vmax,vmin,va,im[1000],jm[1000];

	NZ=nz;
	NR=nr;
	nz1=nz+1;

	vmax= -1e10;
	vmin= 1e10;

	for(i=0;i<=NZ;i++)
		for(j=0;j<=NR;j++){
			va=v[i*nz1+j];
			if(va>vmax) vmax=va;
			else if(va<vmin) vmin=va;
		}

/*	line(XS,YS,XE,YE,5,1,0); */

	for(conto=1;conto<ncont+1;conto++){
        va=vcont[ncont-conto];
		sig=(v[1]>va);		/* ɂ sig = 1 */
		dot=0;				/* ɂ sig = 0 */
		io=0;
		jo=0;
		j=0;
		for(i=0;i<=NZ;i++){
			sign=(v[i*nz1+j]>va);
			if(sig!=sign){
				found(v,va,io,jo,i,j,im,jm,&dot,iro(conto));
				sig=sign;
			}
			io=i;
		}
		for(i=0;i<=NZ;){
			for(j=0;j<=NR;j++){
				sign=(v[i*nz1+j]>va);
				if(sig!=sign){
	 			   found(v,va,io,jo,i,j,im,jm,&dot,iro(conto));
				   sig=sign;
				}
				io=i;
				jo=j;
			}
			i++;
			if(i>NZ) break;
			for(j=NR;j>=0;j--){
				sign=(v[i*nz1+j]>va);
				if(sig!=sign){
				   found(v,va,io,jo,i,j,im,jm,&dot,iro(conto));
				   sig=sign;
				}
				io=i;
				jo=j;
			}
			i++;
		}
	}
}

found(v,va,io,jo,i,j,im,jm,dot,color)
float	va,v[],im[],jm[];
int	io,jo,i,j,*dot,color;
{
	float	ii,jj,*t,*to,eps=1e-4,ai[6],aj[6],r,rn;
	int	k,nogood,kd,c[6];

	nogood=0;
	t=v+i*nz1+j;
	to=v+io*nz1+jo;
	if(io==i){
		ii=i;
		if(*t==*to) jj=(j+jo)/2;
		else jj=(j*(va-*to)-jo*(va-*t))/((*t)-(*to));
	}
	else if(jo==j){
		jj=j;
		if(*t==*to) ii=(i+io)/2;
		else ii=(i*(va-*to)-io*(va-*t))/((*t)-(*to));
	}

	for(k=0;k<*dot;k++)
		if((fabs(im[k]-ii)<eps)&&
		   (fabs(jm[k]-jj)<eps)) nogood=1;

	if(nogood==0){
		im[*dot]=ii;
		jm[*dot]=jj;
		(*dot)++;
	}

	while(nogood==0){
		t=v+i*nz1+j;
		to=v+io*nz1+jo;
		if(io==i){
			c[0]=find(v,va,i  ,j ,i+1,j ,ai  ,aj  ,im,jm,*dot);
			c[1]=find(v,va,i+1,j ,i+1,jo,ai+1,aj+1,im,jm,*dot);
			c[2]=find(v,va,i+1,jo,i  ,jo,ai+2,aj+2,im,jm,*dot);
			c[3]=find(v,va,i  ,jo,i-1,jo,ai+3,aj+3,im,jm,*dot);
			c[4]=find(v,va,i-1,jo,i-1,j ,ai+4,aj+4,im,jm,*dot);
			c[5]=find(v,va,i-1,j ,i  ,j ,ai+5,aj+5,im,jm,*dot);

			r=1e5;
			for(k=0;k<6;k++){
			    if(c[k]==0){
				rn=(ai[k]-im[*dot-1])*(ai[k]-im[*dot-1])
				  +(aj[k]-jm[*dot-1])*(aj[k]-jm[*dot-1]);
				if(rn<r){
					r=rn;
					kd=k;
					ii=ai[k];
					jj=aj[k];
				}
			    }
			}
			if(r==1e5) nogood=1;
			else{
				im[*dot]=ii;
				jm[*dot]=jj;
				(*dot)++;
				switch(kd){
					case 0 :io=i  ;jo=j ;i=i+1;j=j ;break;
					case 1 :io=i+1;jo=jo;i=i+1;j=j ;break;
					case 2 :io=i+1;jo=jo;i=i  ;j=jo;break;
					case 3 :io=i  ;jo=jo;i=i-1;j=jo;break;
					case 4 :io=i-1;jo=jo;i=i-1;j=j ;break;
					case 5 :io=i-1;jo=j ;i=i  ;j=j ;break;
				}
			}
		}
		else if(jo==j){
			c[0]=find(v,va,i ,j  ,i ,j-1,ai  ,aj  ,im,jm,*dot);
			c[1]=find(v,va,i ,j-1,io,j-1,ai+1,aj+1,im,jm,*dot);
			c[2]=find(v,va,io,j-1,io,j  ,ai+2,aj+2,im,jm,*dot);
			c[3]=find(v,va,io,j  ,io,j+1,ai+3,aj+3,im,jm,*dot);
			c[4]=find(v,va,io,j+1,i ,j+1,ai+4,aj+4,im,jm,*dot);
			c[5]=find(v,va,i ,j+1,i ,j  ,ai+5,aj+5,im,jm,*dot);

			r=1e5;
			for(k=0;k<6;k++){
			    if(c[k]==0){
				rn=(ai[k]-im[*dot-1])*(ai[k]-im[*dot-1])
				  +(aj[k]-jm[*dot-1])*(aj[k]-jm[*dot-1]);
				if(rn<r){
					r=rn;
					kd=k;
					ii=ai[k];
					jj=aj[k];
				}
			    }
			}
			if(r==1e5) nogood=1;
			else{
				im[*dot]=ii;
				jm[*dot]=jj;
				(*dot)++;
				switch(kd){
					case 0 :io=i ;jo=j  ;i=i ;j=j-1;break;
					case 1 :io=io;jo=j-1;i=i ;j=j-1;break;
					case 2 :io=io;jo=j-1;i=io;j=j  ;break;
					case 3 :io=io;jo=j  ;i=io;j=j+1;break;
					case 4 :io=io;jo=j+1;i=i ;j=j+1;break;
					case 5 :io=i ;jo=j+1;i=i ;j=j  ;break;
				}
			}
		}
		if(nogood==0)
			oline(im[*dot-2],jm[*dot-2],im[*dot-1],jm[*dot-1],color);
		if(nogood==1){
			for(k=0;k<6;k++)
			    if(c[k]==1)
				oline(ai[k],aj[k],im[*dot-1],jm[*dot-1],color);
		}
	}
}

int find(v,va,i,j,io,jo,ai,aj,im,jm,dot)
float	v[],va,*ai,*aj,im[],jm[];
int	i,j,io,jo,dot;
/* (i,j)(io,jo)̊Ԃ
	cross pointȂ(ai,aj)=(1e5,1e5)AԂ
	o^cross point(ai,aj)ɑAOԂ
	o^ς݂cross point(ai,aj)ɑAPԂ	*/
{
	float	*t,*to,eps=1e-4,ii,jj,nogood;
	int	k;

	*ai=1e5;
	*aj=1e5;
	if((i <0)||(i >NZ)) return(-2);
	if((io<0)||(io>NZ)) return(-3);
	if((j <0)||(j >NR)) return(-4);
	if((jo<0)||(jo>NR)) return(-5);
	t=v+i*nz1+j;
	to=v+io*nz1+jo;
	if((*t<=va)!=(*to<va)){
		nogood=0;
		if(io==i){
			ii=i;
			if(*t==*to) jj=(j+jo)/2;
			else jj=(j*(va-*to)-jo*(va-*t))/((*t)-(*to));
			for(k=0;k<dot;k++)
				if((fabs(im[k]-ii)<eps)&&
				   (fabs(jm[k]-jj)<eps)) nogood=1;
			*ai=ii;
			*aj=jj;
		}
		else if(jo==j){
			jj=j;
			if(*t==*to) ii=(i+io)/2;
			else ii=(i*(va-*to)-io*(va-*t))/((*t)-(*to));
			for(k=0;k<dot;k++)
				if((fabs(im[k]-ii)<eps)&&
				   (fabs(jm[k]-jj)<eps)) nogood=1;
			*ai=ii;
			*aj=jj;
		}
		return(nogood);
	}
	else	return(-1);
}

oline(y1,x1,y2,x2,color)
float y1,x1,y2,x2;
int color;
{
	int	xx1,yy1,xx2,yy2;

	xx1=XS+(XE-XS)*x1/NR;
	xx2=XS+(XE-XS)*x2/NR;
	yy1=YE-(YE-YS)*y1/NZ;
	yy2=YE-(YE-YS)*y2/NZ;
	
	line(xx1,yy1,xx2,yy2,color,0,0);
}

iro(num)
int num;
{
	int	i;

	i=num-num/6*6+1;
	
	return(i);
}
