/*
  DCF2.c   By C.Otani
*/

#include       <stdio.h>
#include       <stdlib.h>
#include       <math.h>

#define        MAX      62500

typedef        struct {
  float           tim;
  float           dat;
  float           err;
  unsigned long   num;
}       DCF;


#include       "set_dcf2.c"
#include       "out_dcf2.c"


main(){

  DCF             dcf[MAX];
  int             c;
  int             k;
  unsigned long   kl, n_dcf;


/*   initialization   */
  for ( kl=0UL; kl<MAX; kl++){
    dcf[k].tim = 0.0;
    dcf[k].dat = 0.0;
    dcf[k].err = 0.0;
    dcf[k].num = 0UL;
  }


/*   read udcf[][] from a file and calculate DCF   */
  if ( ( c = set_dcf2(dcf,&n_dcf) ) == -1 )
    exit(c);


/*   output DCF to a file   */
  if ( ( c = out_dcf2(dcf,n_dcf) ) == -1 )
    exit(c);

  return(0);

}









