/* fitspec.c  Ver 3.0   1991.8.6. */
/* եåȷ̤ɤ߹ǡڥȥ */
/* pasfont.datȤʤ */
/* plot1.c, fitread.cȥ󥯤뤳 */
/* returnǽλ */

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "fitspec.h"

main(int argn, char *args[])

{
	static struct fit_spec	*spect[SPECTNUM];
	static double	xmin,xmax,ymin,ymax,total;
	static char	filename[30],title[80],x_ziku[80],y_ziku[80];
	static int	i,subspecnum,sf,xlog,ylog;
	static char	work[100];

	for(i=0;i<SPECTNUM;i++){
		if((spect[i]=malloc(sizeof(struct fit_spec)))==NULL){
			printf("can't obtain memory\n");
			exit(0);
		}
	}

	if(fit_fileread(filename,&subspecnum,spect,argn,args)==0) exit(0);
	sf= -1;
	while(1){
		printf(" %s ˤ %d ĤΥڥȥեåȤޤ\n",
			filename,subspecnum);
		if(subspecnum==1 && sf==-1) sf=1;
		else{
			do{
				printf("ܤΥեåȤɽޤ ");
				sf=subspecnum+1;
				gets(work);
				i=work[0];
				i=toupper(i);
				if(i==0) exit(0);
				else sscanf(work,"%d",&sf);
			}while((sf<1)||(sf>subspecnum));
		}

		sf--;
		xlog=1;
		ylog=1;
		ymin=1.0;		/* ylog=1 λ ymax/ymin  Y ηͿ */
		ymax=10000.0;

		if(spect[sf]->ee[spect[sf]->ndata-1] < 40.0){
			xmin=0.5;
			xmax=50.0;
		}
		else{
			xmin=1.0;
			xmax=70.0;
		}

		total=0;
		for(i=0;i<spect[sf]->ndata;i++) total+=spect[sf]->counts[i];

		sprintf(title,"  %7.2lfc/s  %s %d %d",
			total,spect[sf]->datafile,spect[sf]->subfilenum,spect[sf]->datanum);
		sprintf(x_ziku,"       ENERGY [KeV]      X2red=%5.2lf",
			spect[sf]->chisqrred);
		strcpy(y_ziku, "COUNTS [c/s/KeV]");

		text_write(spect[sf]);
		fitspec(spect[sf],xlog,xmin,xmax,ylog,ymin,ymax,title,x_ziku,y_ziku);
		sf++;
	}
}

text_write(spect)
struct fit_spec *spect;
{
	int	k;
	char	work[255];

	screen(3,0,0,1);
	cls(3);

	smallmoji(1,400,"BINNING :",5,0,0);
	sprintf(work,"%s",spect->binning); smallmoji(1,413,work,5,0,0);
	sprintf(work,"NO. of DATA : %d",spect->ndata); smallmoji(1,426,work,5,0,0);

	smallmoji(1,439,"MODEL :",5,0,0);
	sprintf(work,"%s",spect->modelformula); smallmoji(1,452,work,5,0,0);

	smallmoji(1,465,"NUMBER : ",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%4d   ",k+1); smallmoji(57+56*k,465,work,5,0,0);
	}
	smallmoji(1,478,"INITIAL:",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->parainit[k]); smallmoji(57+56*k,478,work,5,0,0);
	}
	smallmoji(1,491,"LOWER  :",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->paralow[k]); smallmoji(57+56*k,491,work,5,0,0);
	}
	smallmoji(1,504,"UPPER  :",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->paraup[k]); smallmoji(57+56*k,504,work,5,0,0);
	}
	smallmoji(1,530,"FINAL  :",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->parafinal[k]); smallmoji(57+56*k,530,work,5,0,0);
	}
	smallmoji(1,543,"90 ERR:",5,0,0);
	for(k=0;k<spect->npara;k++){
	  sprintf(work,"%7.3lf",spect->paraerr[k]); smallmoji(57+56*k,543,work,5,0,0);
	}

	sprintf(work,"    2      %7.2lf   ",spect->chisqr);
	smallmoji(1,569,work,5,0,0);
	sprintf(work,"(D.O.F.=%d)",spect->dof);
	smallmoji(201,569,work,5,0,0);
	sprintf(work,"reduced 2  %7.2lf",spect->chisqrred);
	smallmoji(1,582,work,5,0,0);
	sprintf(work,"SIMPLEX : %d STEPS",spect->simplex);
	smallmoji(1,608,work,5,0,0);
	sprintf(work,"LSQ     : %d STEPS",spect->lsq);
	smallmoji(1,621,work,5,0,0);
	sprintf(work,"%s",spect->converge);
	smallmoji(1,634,work,5,0,0);
}

fitspec(spect,xlog,xmin,xmax,ylog,ymin,ymax,title,x_ziku,y_ziku)
struct fit_spec *spect;
double xmin,xmax,ymin,ymax;
int xlog,ylog;
char title[],y_ziku[],x_ziku[];
{
	static struct fit_spec	spect1;
	double			gx0, gx1, gy0, gy1, xunit, yunit,dum,
					x[48],xstdv[48],y[48],ystdv[48];
	int				i,j;
/*	char			s[4]; */
	
/*        s[0]=' '; */
	spect1 = *spect;

	gx0 = 150.0;
	gx1 = 470.0;
	gy0 = 145.0;
	gy1 = 370.0;
	xunit = 0.0;
	yunit = 0.0;

	load_font();

	for(i=0;i<spect1.ndata;i++){
		x[i]=(spect1.ee[i]+spect1.es[i])/2;
		xstdv[i]=spect1.ee[i]-x[i];
		dum=1/(spect1.ee[i]-spect1.es[i]);
		y[i]=spect1.counts[i]*dum;
		ystdv[i]=spect1.stdv[i]*dum;
		spect1.model[i]=spect1.model[i]*dum;
		for(j=0;j<spect1.ncompo;j++)
                   spect1.compo[j][i]=spect1.compo[j][i]*dum;
	}

	if(ylog==1){
		ymin=ymin/ymax;
		ymax=0;
		for(i=0;i<spect1.ndata;i++)
			if(ymax<y[i]) ymax=y[i];
		ymax=exp(floor(log(ymax))+1.0);
		ymin=ymax*ymin;
	}

	axsa(gx0,gx1,xmin,xmax,xlog,xunit,gy0,gy1,ymin,ymax,ylog,yunit,
		" ",y_ziku,title,1);

	pointb(x,xstdv,y,ystdv,spect1.ndata-1,6);
	hist(spect1.model,spect1.es,spect1.ee,spect1.ndata-1);
	for(i=0;i<spect1.ncompo;i++)
		hist(spect1.compo[i],spect1.es,spect1.ee,spect1.ndata-1);

        flush();
	gy0 =  50.0;
	gy1 = 120.0;
	yunit = 3.0;
	ylog =  0;
	ymin = -6;
	ymax =  6;
	strcpy(y_ziku,"    RES.");

	axsa(gx0,gx1,xmin,xmax,xlog,xunit,gy0,gy1,ymin,ymax,ylog,yunit,
		x_ziku,y_ziku," ",4);

	for(i=0;i<spect1.ndata;i++){
		y[i]=spect1.res[i]/spect1.stdv[i];
		ystdv[i]=1.0;
	}

	pointb(x,xstdv,y,ystdv,spect1.ndata-1,6);
        flush();

}
