/*                                               */
/*       SUBROUTIN "read_data3.c"   ver 1.0      */
/*                                               */
/*           92.9.11   by C.Otani                */
/*                                               */
#include       <stdio.h>
#include       <stdlib.h>


int read_data(RAW a[], RAW b[], int *na, int *nb){


  int        k, k1, k2, c;
  int        data_a, data_b;
  char       fname[50], str[10];
  FILE       *fp;
  float      temp;


/*   Input parameters   */
  printf("\nInput file name > "); gets(fname);
  data_a = 1; data_b = 0;
  while ( data_a > data_b ){
    printf("number of data > "); gets(str); NBAND = atoi(str); 
    printf("1st bin number > "); gets(str); data_a = atoi(str); 
    printf("2nd bin number > "); gets(str); data_b = atoi(str); 
  }


/*   read data   */
  if ( ( fp = fopen(fname, "r") ) == NULL ){
    printf("\nFile open error !!\n");
    return(-1);
  }
  k=0;
  if ( data_a != data_b){
    while( fscanf(fp, "%lf", &a[k].tim) != EOF ){ /*   read time */
      for ( k1=0;      k1<data_a; k1++) fscanf(fp,"%f", &a[k].dat);
      for ( k1=data_a; k1<data_b; k1++) fscanf(fp,"%f", &b[k].dat);
      for ( k1=data_b; k1<NBAND;  k1++) fscanf(fp,"%f", &temp);
      for ( k2=0;      k2<data_a; k2++) fscanf(fp,"%f", &a[k].err);
      for ( k2=data_a; k2<data_b; k2++) fscanf(fp,"%f", &b[k].err);
      for ( k2=data_b; k2<NBAND;  k2++) fscanf(fp,"%f", &temp);
      b[k].tim = a[k].tim;
      k++;
      printf("%6d\r",k);
    }
  }
  else {
    while( fscanf(fp, "%lf", &a[k].tim) != EOF ){ /*   read time */
      for ( k1=0;      k1<data_a; k1++) fscanf(fp,"%f", &a[k].dat);
      for ( k1=data_a; k1<NBAND;  k1++) fscanf(fp,"%f", &temp);
      for ( k2=0;      k2<data_a; k2++) fscanf(fp,"%f", &a[k].err);
      for ( k2=data_a; k2<NBAND;  k2++) fscanf(fp,"%f", &temp);
      b[k].tim = a[k].tim;
      b[k].dat = a[k].dat;
      b[k].err = a[k].err;
      k++;
      printf("%6d\r",k);
    }
  }
  *na = *nb = k;

  fclose(fp);
  return(0);

}



