/* scanread.c  Ver 1.0  1992.4.21. */
/* եɤ */
/* ǥեȤĤ */

#include <math.h>
#include <stdio.h>
#include <string.h>

#include "fitscan.h"

FILE *file_read_open_default(char mes[],char defaults[],char filename[])
{
	FILE	*fp;

	while(1){
		fprintf(stderr,"%s [.%s]= ? ",mes,defaults);
		gets(filename);
		if((fp=fopen(filename,"r"))!=NULL) break;
		fprintf(stderr," %s ޤ\n",filename);
		strcat(filename,".");
		strcat(filename,defaults);
		if((fp=fopen(filename,"r"))!=NULL) break;
		fprintf(stderr," %s ޤ\n",filename);
	}
	fprintf(stderr," %s ɤǤޤ\n",filename);
	return(fp);
}

FILE *file_read_open_arg_default(int argn,char *args[],char defaults[],char filename[])
{
	FILE	*fp;
	int	i;

	if(argn<=1) return(NULL);
	for(i=1;i<argn;i++){
		strcpy(filename,args[i]);
		if((fp=fopen(filename,"r"))!=NULL) break;
		fprintf(stderr," %s ޤ\n",filename);
		strcat(filename,".");
		strcat(filename,defaults);
		if((fp=fopen(filename,"r"))!=NULL) break;
		fprintf(stderr," %s ޤ\n",filename);
	}
	if(fp!=NULL) fprintf(stderr," %s ɤǤޤ\n",filename);
	return(fp);
}

fit_fileread(filename,subfilenum,spect,argn,args)
char filename[];
int *subfilenum;
struct fit_spec *spect[];
int argn;
char *args[];
{
	int			line,num,i;
	FILE		*fp;
	static char	data[150][160],work[300],
			beginword[50]="***** RESULTS OF SCAN PROFILE FITTING";

	if((fp=file_read_open_arg_default(argn,args,"fit",filename))==NULL){
		fp=file_read_open_default("ϥեåȥե̾","fit",filename);
	}

	line=0;			/* data[0..line-1]˥ڥȥեɤ߹ */
	num=0;
	while(fgets(work,300,fp)!=NULL){
		i=strlen(work)-1;
		do{
			i--;
		}while(work[i]==' ' && i!=-1);
		work[i+1]=0;
		strcpy(data[line],work);
		if(strstr(data[line],beginword)!=NULL){
			num++;
			if(num>1){
				fit_dataread(data,line,spect[num-2]);
			}
			printf(" %s Υ֥ե %d ɤǤޤ%c",filename,num,0x0d);
			strcpy(data[0],data[line]);
			line=0;
		}
		line++;
	}
	fclose(fp);

	if(num>0){
		if(fit_dataread(data,line,spect[num-1])==0) num--;
	}
	if(num==0){
		printf("\n %s ˤ եåȥե뤬ޤ\n",filename);
	}
	*subfilenum=num;
	return(num);	/* 0 */
}

/* beginwordǻϤޤ1֥åǡɤ߹ */
fit_dataread(data,line,spect)
char data[150][160];
int line;
struct fit_spec *spect;
{
	int	i,j,k,n,cont;
	char	work[175],*p;

	i=0;
	if(gountil(data,"DATASET NAME",&i,line)==1){
		printf("ǡޤ\n");
		return(0);	/* 0ϥ */
	}
	strcpy(spect->datafile,strchr(data[i],(int)';')+2);	/* ե̾ */
	k=strlen(spect->datafile);
	if(spect->datafile[k-1]=='\n') spect->datafile[k-1]=0;

	spect->subfilenum = 1;
	spect->datanum = 1;

	i++;
	if(gountil(data,"ENERGY BANDS USED",&i,line)==1){
		printf("ǡޤ\n");
		return(0);	/* 0ϥ */
	}
	strcpy(spect->binning,strchr(data[i],(int)';')+2);	/* energy bands used */

	gountil(data,"NO. OF DATA",&i,line);
	sscanf(strchr(data[i],(int)';')+1,"%d",&(spect->ndata));

	gountil(data,"MODEL FORMULA",&i,line);
	i++;
	p=data[i];
	while(*p==' ') p++;
	strcpy(spect->modelformula,p);
	spect->ncompo=1;
	while(*p){		/* ʰ  ʬ */
		if(*p=='+') spect->ncompo++;
		p++;
	}
	if(spect->ncompo>COMPONUM){
		printf("EROOR !!! Components too many (%d). Chenge COMPONUM.\n",spect->ncompo);
		exit(0);
	}

	gountil(data,"PARAMETERS",&i,line);
	i++;
	strcpy(work,data[i]);
	if(strstr(data[i+1],"INITIAL")==NULL){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
		cont=1;
		i++;
	}
	else cont=0;

	k=strlen(work);
	n=25;
	do{
		sscanf(&work[n],"%d",&(spect->npara));
		n+=9;
	}while(n<k);

	if(spect->npara>PARANUM){
		printf("EROOR !!! Parameters too many (%d). Chenge PARANUM.\n",spect->npara);
		exit(0);
	}

	gountil(data,"INITIAL",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->parainit[n]));
	}

	gountil(data,"LOWER",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paralow[n]));
	}

	gountil(data,"UPPER",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paraup[n]));
	}

	gountil(data,"FINAL",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->parafinal[n]));
	}

	gountil(data,"90% ERROR",&i,line);
	strcpy(work,data[i]);
	if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	}
	p=work;
	p+=24;
	for(n=0;n<spect->npara;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paraerr[n]));
	}

    while(1){
      strcpy(work,data[i+2]);
      for(n=0;n<20;n++)
          if(work[n]!=' ') break;
      if(n!=20) break;
      i++;
    }
    if(work[10]=='N' && work[11]=='U' && work[12]=='M'){
	  k=strlen(work);
	  n=25;
	  do{
  		sscanf(&work[n],"%d",&(spect->npara2));
		n+=9;
	  }while(n<k);
  
	  if(spect->npara2>PARANUM){
  		printf("EROOR !!! Parameters too many (%d). Chenge PARANUM.\n",spect->npara2);
  		exit(0);
      }

	  gountil(data,"INITIAL",&i,line);
	  strcpy(work,data[i]);
	  if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	  }
	  p=work;
 	  p+=24;
	  for(n=spect->npara;n<spect->npara2;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->parainit[n]));
	  }

	  gountil(data,"LOWER",&i,line);
	  strcpy(work,data[i]);
	  if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	  }
	  p=work;
	  p+=24;
	  for(n=spect->npara;n<spect->npara2;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paralow[n]));
	  }

	  gountil(data,"UPPER",&i,line);
	  strcpy(work,data[i]);
	  if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	  }
	  p=work;
	  p+=24;
	  for(n=spect->npara;n<spect->npara2;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paraup[n]));
	  }

	  gountil(data,"FINAL",&i,line);
	  strcpy(work,data[i]);
	  if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	  }
	  p=work;
 	  p+=24;
	  for(n=spect->npara;n<spect->npara2;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->parafinal[n]));
	  }

	  gountil(data,"90% ERROR",&i,line);
	  strcpy(work,data[i]);
	  if(cont){
		work[strlen(work)-1]=0;
		strcat(work,data[i+1]);
	  }
	  p=work;
	  p+=24;
	  for(n=spect->npara;n<spect->npara2;n++,p+=9){
		k=sscanf(p,"%lf",&(spect->paraerr[n])) ; printf("err[%d]=%lf ",n,spect->paraerr[n]);
	  }

      spect->npara=spect->npara2;
    }

	gountil(data,"CHI SQUARED VALUE",&i,line);
	p =data[i];
	p+=27;
	sscanf(p,"%lf",&(spect->chisqr));
	p+=21;
	sscanf(p,"%d",&(spect->dof));

	spect->nparaeff=spect->npara;
	for(i=0;i<spect->npara;i++)
	    if((spect->paraup[i]==0)&&(spect->paralow[i]==0)){
			spect->nparaeff--;
		}

	if(spect->ndata-spect->nparaeff!=spect->dof){
		printf("data error !!!\n");
		printf("Data of freedom  Nbin - Nparaeff ʤ\n");
		printf("DOF=%d, Nbin=%d,  Nparaeff=%d Npara=%d\n",
			spect->dof,spect->ndata,spect->nparaeff,spect->npara);
/*		for(k=0;k<line;k++) printf("%s",data[k]);*/
		exit(1);
	}

	gountil(data,"REDUCED VALUE",&i,line);
	p=data[i];
	p+=27;
	sscanf(p,"%lf",&(spect->chisqrred));

	i++;
	p=data[i];
	p+=28;
	sscanf(p,"%d",&(spect->simplex));
	p+=23;
	sscanf(p,"%d",&(spect->lsq));

	i++;
	p=data[i]+1;
	while(*p==' ') p++;
	strcpy(spect->converge,p);

	i+=3;
	for(k=0;k<spect->ndata;){
		if(data[i][15]=='-'){
			strcpy(work,data[i]);
			if(cont){
				work[strlen(work)-1]=0;
				strcat(work,data[i+1]);
				i++;
			}
			p=work;
			sscanf(&(work[ 8]),"%lf",&(spect->es[k]));
			sscanf(&(work[16]),"%lf",&(spect->ee[k]));
			sscanf(&(work[25]),"%lf",&(spect->counts[k]));
			sscanf(&(work[35]),"%lf",&(spect->stdv[k]));
			sscanf(&(work[46]),"%lf",&(spect->model[k]));
			sscanf(&(work[59]),"%lf",&(spect->res[k]));
			for(j=0;j<spect->ncompo;j++){
				sscanf(&(work[72+12*j]),"%lf",&(spect->compo[j][k]));
			}
			k++;
		}
		i++;
	}
	return(1);	/* 1OK */
}

gountil(data,s,i,line)
char data[][160],s[];
int *i,line;
{
	while( (strstr(data[*i],s) == NULL) && (*i < line)) (*i)++;
	if( (*i) >= line){
		printf(" ERROR !!  %s Υǡޤ\n",s);
		return(1);
	}
	return(0);
}
