/*
  Program UDCF2.C   BY C.OTANI
*/


#include       <stdio.h>
#include       <stdlib.h>
#include       <math.h>

#define        IMAX     30000
#define        JMAX     30000

typedef struct {
  double       tim;
  float        dat;
  float        err;
} RAW;

int            NBAND=10;


#include       "read_data0.c"
#include       "udcfsub.c"


main(){

  RAW          a[IMAX], b[JMAX];
  int          c, na, nb;
  int          k, k1, k2;
  long         kl, nab;
  char         str[10];


/*   initialization   */
  for ( k1=0; k1<IMAX; k1++)
    a[k1].tim = a[k1].dat = a[k1].err = 0.0;
  for ( k1=0; k1<IMAX; k1++)
    b[k1].tim = b[k1].dat = b[k1].err = 0.0;


/*   read a[][] & b[][] from a file   */
  if ( (c = read_data(a,b,&na,&nb)) == -1 )
    exit(c);


/*  calculate UDCF   */
  c = udcfsub(a,b,na,nb,&nab);

  return(c);
  }

















